<div class="workflow-right-header workflow-header">Manage Authors</div>
<div class="flex-container">
  <div class="column-layout">
    <span>PUBLISHER</span>
    <mat-divider></mat-divider>
    <form class="publisher-form-layout" [formGroup]="publisherForm">
      <div class="column-flex-grow">
        <mat-label>Publisher Name </mat-label>
        <div class="flex-column">
          <mat-form-field>
            <input class="full-width" matInput formControlName="name" />
            @if (publisherForm.value.name) {
              <button
                matSuffix
                mat-icon-button
                aria-label="Clear"
                (click)="publisherForm.setValue({ name: '' })"
              >
                <mat-icon>close</mat-icon>
              </button>
            }
            @if (
              publisherForm.controls["name"].hasError("required") &&
              publisherForm.controls["name"].touched
            ) {
              <mat-error class="modal-error"
                >Publisher name is required</mat-error
              >
            }

            @if (
              publisherForm.controls["name"].errors?.["minlength"] &&
              publisherForm.controls["name"].touched
            ) {
              <mat-error class="modal-error"
                >Publisher name should contain at least 2 characters.</mat-error
              >
            }
            @if (
              publisherForm.controls["name"].errors?.["pattern"] &&
              publisherForm.controls["name"].touched
            ) {
              <mat-error class="modal-error"
                >Publisher name must contain only alphanumeric
                letters.</mat-error
              >
            }
            @if (publisherForm.get("name")?.hasError("sameAsPublisher")) {
              <mat-error class="modal-error"
                >Please type in a new publisher name to save changes.</mat-error
              >
            }
          </mat-form-field>
        </div>
      </div>

      <div class="button-row">
        <button
          class="discard-changes-button"
          mat-raised-button
          (click)="onCancelClick()"
        >
          Discard changes
        </button>
        <button
          class="save-button"
          color="primary"
          mat-raised-button
          (click)="OnEditPublisherClick()"
          [disabled]="!publisherForm.controls['name'].value"
        >
          Save
        </button>
      </div>
    </form>
  </div>
  <mat-divider vertical class="flexible-height-divider"></mat-divider>
  <div class="author-form-layout">
    <span>AUTHORS</span>
    <mat-divider></mat-divider>
    <mat-chip-set #chipGrid>
      @for (author of authorsList; track author) {
        <mat-chip-row (removed)="onRemoveAuthorClick(author)">
          {{ author.name }}
          <button matChipRemove [attr.aria-label]="'remove ' + author.name">
            <mat-icon>cancel</mat-icon>
          </button>
        </mat-chip-row>
      } @empty {
        <span>No authors listed.</span>
      }
    </mat-chip-set>
    Please add additional names of one or more author of this model.
    <form
      class="flex-column full-height"
      [formGroup]="authorForm"
      #formDirective="ngForm"
    >
      <div class="flex-column flex-grow">
        <div class="flex-column">
          <mat-label class="asterisk--after">Name </mat-label>
          <mat-form-field>
            <input class="full-width" matInput formControlName="name" />
            @if (authorForm.value.name) {
              <button
                matSuffix
                mat-icon-button
                aria-label="Clear"
                (click)="authorForm.controls['name'].setValue('')"
              >
                <mat-icon>close</mat-icon>
              </button>
            }
            @if (authorForm.controls["contact"].hasError("required")) {
              <mat-error class="modal-error">Name is required</mat-error>
            }
          </mat-form-field>
        </div>
        <div class="flex-column">
          <mat-label class="asterisk--after"> Contact Info</mat-label>
          <div class="flex-column">
            <mat-form-field>
              <input class="full-width" matInput formControlName="contact" />
              @if (authorForm.value.contact) {
                <button
                  matSuffix
                  mat-icon-button
                  aria-label="Clear"
                  (click)="authorForm.controls['contact'].setValue('')"
                >
                  <mat-icon>close</mat-icon>
                </button>
              }
              <mat-hint align="start" class="modal-note full-width"
                >You can mention Email Address,URL and Phone Number
              </mat-hint>
            </mat-form-field>
            @if (
              authorForm.controls["contact"].hasError("required") &&
              authorForm.controls["contact"].touched
            ) {
              <mat-error class="modal-error"
                >Contact info is required</mat-error
              >
            }
          </div>
        </div>
      </div>
      <button
        color="primary"
        class="add-author-button"
        mat-raised-button
        (click)="onAddAuthorClick(formDirective)"
        [disabled]="!authorForm.valid"
      >
        Add author
      </button>
    </form>
  </div>
</div>
